<?

/*
	Show sudoku's from database

        (C) Copyright 2005 by Mogens Kjaer, mk@lemo.dk

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful, 
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License 
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

include('utilities.php');

sudoku_db();

echo "<HTML>\n";
echo "<HEAD>\n";
echo "  <META HTTP-EQUIV=\"content-type\" CONTENT=\"TEXT/HTML; CHARSET=ISO-8859-1\">\n";
echo "  <META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">\n";
if($lang==0)
  echo "  <TITLE>Sudoku opgaver</TITLE>\n";
else
  echo "  <TITLE>Sudoku puzzles</TITLE>\n";
echo "  <link rel=\"stylesheet\" type=\"text/css\" href=\"sudoku.css\" title=\"Default\">\n";
echo "</HEAD>\n";
echo "<body>\n";

if(isset($nx)&&isset($ny)&&isset($ndigits)&&isset($level)&&isset($symmetrical)&&!isset($serial))
{
  $res1 = mysql_query("select serial from sudoku where nx=".intval($nx)." and ny=".intval($ny).
                      " and ndigits=".intval($ndigits)." and level=".intval($level)." and ".
		      "symmetrical=".intval($symmetrical)." order by lastused limit 1");
  if($row1 = mysql_fetch_assoc($res1))
  {
    $serial = $row1["serial"];
  }
}

if(isset($serial))
{
  $res1=mysql_query("select * from sudoku where serial=".intval($serial));
  if($row1 = mysql_fetch_assoc($res1))
  {
    if($lang==0)
      echo "<h1>Opgave nr. ".$row1["serial"]."</h1>\n";
    else
      echo "<h1>Puzzle no. ".$row1["serial"]."</h1>\n";
    $nx = $row1["nx"];
    $ny = $row1["ny"];
    $res2 = mysql_query("update sudoku set lastused=now() where serial=".intval($serial));
    $nxny = $nx*$ny;
    $res2 = mysql_query("select * from solutions where serial=".$row1["serial"]);
    if($row2 = mysql_fetch_assoc($res2)) $thissolution = $row2["solution"];
    $res2 = mysql_query("select * from problems where serial=".$row1["serial"]);
    if($row2 = mysql_fetch_assoc($res2)) $thisproblem = $row2["problem"];
    if(isset($solution) || isset($explanation))
    {
      $txt = $thissolution;
    }
    else
    {
      $txt = $thisproblem;
    }
    echo "<p align=center>";
    echo "<table class=\"s\">\n";
    $index=0;
    for($i=0;$i<$nxny;$i++)
    {
      echo "<tr class=\"s\">";
      for($j=0;$j<$nxny;$j++)
      {
	$c = substr($txt,$index,1);
        echo "<td class=\"s";
	if(($i%$nx)==0 && $i>0) echo " thicktop";
	if((($j+1)%$ny)==0 && $j<($nxny-1)) echo " thickright";
	if($c!="0" && substr($thisproblem,$index,1)=="0") echo " solution";
	echo "\">";
	if($c=="0")
	{
	  echo "&nbsp;";
	}
	else
	{
	  echo $c;
	}
	echo "</td>\n";
	$index++;
      }
      echo "</tr>\n";
    }
    echo "</table></p>\n";
    echo "<p></p>\n";
    if($lang==0)
      echo "<p class=\"s\">Opgavetype: ".level_text($row1["level"]);
    else
      echo "<p class=\"s\">Puzzle type: ".level_text($row1["level"]);
    echo "<br>\n";
    if($lang==0)
      echo "Symmetri: ".symmetrical_text($row1["symmetrical"]);
    else
      echo "Symmetry: ".symmetrical_text($row1["symmetrical"]);
    echo "<br>\n";
    if($lang==0)
      echo "Niveau: ".$row1["abslevel"];
    else
      echo "Level: ".$row1["abslevel"];
    if(isset($solution) || isset($explanation))
    {
      echo "<br><a href=\"".$PHP_SELF."?serial=".$serial."\">";
      if($lang==0)
        echo "Vis opgave</a>";
      else
        echo "Show puzzle</a>";
      echo "<br><a href=\"pdf.php?serial=".$serial."&solution\">";
      if($lang==0)
        echo "Vis lsning som PDF</a>";
      else
        echo "Show solution as PDF</a>";
    }
    if(isset($solution) && !isset($explanation))
    {
      echo "<br><a href=\"".$PHP_SELF."?serial=".$serial."&solution&explanation\">";
      if($lang==0)
        echo "Vis forklaring</a>";
      else
        echo "Show explanation</a>";
    }
    if(isset($solution) && isset($explanation))
    {
      echo "<br><a href=\"".$PHP_SELF."?serial=".$serial."&solution\">";
      if($lang==0)
        echo "Skjul forklaring</a>";
      else
        echo "Hide explanation</a>";
    }
    if(!isset($solution) && !isset($explanation))
    {
      echo "<br><a href=\"sudokusolve.php?serial=".$serial."\">";
      if($lang==0)
	echo "Ls online!</a>";
      else
	echo "Solve online!</a>";
      echo "<br><a href=\"pdf.php?serial=".$serial."\">";
      if($lang==0)
        echo "Vis opgave som PDF</a>";
      else
        echo "Show puzzle as PDF</a>";
      echo "<br><a href=\"pdf.php?serial=".$serial."&showpossibilities\">";
      if($lang==0)
        echo "Vis opgave som PDF med mulige kandidater</a>";
      else
        echo "Show puzzle as PDF with possible candidates</a>";
      echo "<br><a href=\"".$PHP_SELF."?serial=".$serial."&solution\">";
      if($lang==0)
        echo "Vis lsning</a>";
      else
        echo "Show solution</a>";
      $res2 = mysql_query("select counter from statistics ".
                          "where nx=".$row1["nx"].
			  " and ny=".$row1["ny"].
			  " and ndigits=".$row1["ndigits"].
			  " and level=".$row1["level"].
			  " and symmetrical=".$row1["symmetrical"]);
      if($row2 = mysql_fetch_assoc($res2))
      {
        if($row2["counter"]>1)
	{
	  echo "<br><a href=\"".$PHP_SELF."?nx=".$row1["nx"].
				       "&ny=".$row1["ny"].
				       "&ndigits=".$row1["ndigits"].
				       "&level=".$row1["level"].
				       "&symmetrical=".$row1["symmetrical"]."\">";
	  if($lang==0)
	    echo "Vis anden opgave af samme type</a> af ".$row2["counter"]." mulige\n";
	  else
	    echo "Show another puzzle of the same type</a> out of ".$row2["counter"]." possible\n";
	}
      }
      echo "<br><a href=\"".$PHP_SELF."\">";
      if($lang==0)
	echo "Alle opgavetyper</a>";
      else
	echo "All puzzle types</a>";
    }
    if(isset($explanation))
    {
      if($lang==0)
        echo "<h2 align=center>Forklaring til lsning:</h2>";
      else
        echo "<h2 align=center>Explanation to solution:</h2>";
      $res2 = mysql_query("select * from explanations where serial=".$row1["serial"]);
      if($row2 = mysql_fetch_assoc($res2)) $p = $row2["explanation"];
      echo "<p align=center>";
      while($p!="")
      {
        $i = logtext($p, $etxt);
	echo $etxt."<br>\n";
	$p = substr($p, $i);
      }
      echo "</p>\n";
    }
  }
  else
  {
    if($lang==0)
    {
      echo "<h1>Fejl!</h1>\n";
      echo "<p>Opgave ".$serial." findes ikke.</p>\n";
    }
    else
    {
      echo "<h1>Error!</h1>\n";
      echo "<p>Puzzle ".$serial." does not exist.</p>\n";
    }
  }
}
else if(isset($nx)&&isset($ny)&&isset($symmetrical)&&isset($level))
{
  echo "<h1>".$nx."x".$ny;
  if($lang==0)
  {
    echo " opgaver, symmetri: ";
  }
  else
  {
    echo " puzzles, symmetry: ";
  }
  echo symmetrical_text($symmetrical);
  if($lang==0)
  {
    echo ", svrhedsgrad: ";
  }
  else
  {
    echo ", difficulty: ";
  }
  echo level_text($level)."</h1>\n";
  echo "<table border=1>\n";
  if($lang==0)
    echo "<th>Antal fyldte celler<th>Antal\n";
  else
    echo "<th>Number of filled cells<th>Number\n";
  $res1 = mysql_query("select ndigits,sum(counter) as counter from statistics where nx=".intval($nx).
                      " and ny=".intval($ny).
                      " and symmetrical=".intval($symmetrical)." and level=".intval($level)." group by ndigits");
  while($row1 = mysql_fetch_assoc($res1))
  {
    echo "<tr>";
    echo "<td align=center><a href=\"".$PHP_SELF."?nx=".$nx."&ny=".$ny."&symmetrical=".$symmetrical."&level=".$level."&ndigits=".$row1["ndigits"]."\">";
    echo $row1["ndigits"];
    echo "</a>";
    echo "<td align=right>".$row1["counter"];
  }
  echo "</table>\n";
}
else if(isset($nx)&&isset($ny)&&isset($symmetrical))
{
  echo "<h1>".$nx."x".$ny;
  if($lang==0)
  {
    echo " opgaver, symmetri: ";
  }
  else
  {
    echo " puzzles, symmetry: ";
  }
  echo symmetrical_text($symmetrical)."</h1>\n";
  echo "<table border=1>\n";
  if($lang==0)
    echo "<th>Svrhedsgrad<th>Antal\n";
  else
    echo "<th>Difficulty<th>Number\n";
  $res1 = mysql_query("select level,sum(counter) as counter from statistics where nx=".intval($nx).
                      " and ny=".intval($ny).
                      " and symmetrical=".intval($symmetrical)." group by level");
  while($row1 = mysql_fetch_assoc($res1))
  {
    echo "<tr>";
    echo "<td align=center><a href=\"".$PHP_SELF."?nx=".$nx."&ny=".$ny."&symmetrical=".$symmetrical."&level=".$row1["level"]."\">";
    echo level_text($row1["level"]);
    echo "</a>";
    echo "<td align=right>".$row1["counter"];
  }
  echo "</table>\n";
  if($lang==0)
  {
    echo "<p>Se i <a href=\"faq.html#2\">FAQ'en</a> for en forklaring p svrhedsgraderne.</p>\n";
    echo "<p>De fleste opgaver, jeg har set i danske aviser, er af svrhedsgraderne <b>Meget nem</b> eller <b>Nem</b>.</p>\n";
    echo "<p>Bemrk, at opgaver i svrhedsgraden <b>Meget svr</b> kun kan lses ved at gtte. Nogle af disse opgaver kan tage flere minutter at lse p en hurtig computer!</p>\n";
  }
  else
  {
    echo "<p>Please see the <a href=\"faq.html#2\">FAQ</a> for an explanation to the level of difficulty.</p>\n";
    echo "<p>Most of the puzzles I've seen in Danish newspapers belong in the categories <b>Very easy</b> or <b>Easy</b>.</p>\n";
    echo "<ip>Note that puzzles in the category <b>Difficult</b> can only be solved by guessing. The solution of these puzzles can take several minutes on a fast computer!</p>\n";
  }
}
else
{
  if($lang==0)
    echo "<h1>Opgavetyper</h1>\n";
  else
    echo "<h1>Puzzle types</h1>\n";
  echo "<table border=1>\n";
  if($lang==0)
    echo "<tr><th rowspan=2>Strrelse<th colspan=3>Antal opgaver:<br>Symmetri\n";
  else
    echo "<tr><th rowspan=2>Size<th colspan=3>Number of puzzles:<br>Symmetry\n";
  echo "<tr>";
  for($i=0;$i<=2;$i++)
    echo "<td>".symmetrical_text($i);
  $res1 = mysql_query("select nx,ny,symmetrical,sum(counter) as counter from statistics group by nx,ny,symmetrical");
  $lastnx=999;
  $lastny=999;
  $lastsymmetrical=2;
  $ntotal = 0;
  while($row1 = mysql_fetch_assoc($res1))
  {
    if($lastnx != $row1["nx"] ||
       $lastny != $row1["ny"])
    {
      for($i=0;$i<(2-$lastsymmetrical);$i++)
      {
	echo "<td>&nbsp;";
      }
      echo "<tr>";
      echo "<td align=center>".$row1["nx"]."x".$row1["ny"];
      $lastsymmetrical=-1;
    }
    for($i=0;$i<($row1["symmetrical"]-$lastsymmetrical-1);$i++)
    {
      echo "<td>&nbsp;";
    }
    echo "<td align=right><a href=\"".$PHP_SELF."?nx=".$row1["nx"]."&ny=".$row1["ny"]."&symmetrical=".$row1["symmetrical"]."\">".$row1["counter"]."</a>\n";
    $lastnx = $row1["nx"];
    $lastny = $row1["ny"];
    $lastsymmetrical = $row1["symmetrical"];
    $ntotal += $row1["counter"];
  }
  for($i=0;$i<(2-$lastsymmetrical);$i++)
  {
    echo "<td>&nbsp;";
  }
  echo "</table>\n";
  echo "<p></p>\n";
  if($lang == 0)
    echo "<p>Databasen indeholder i alt ".$ntotal." opgaver!</p>\n";
  else
    echo "<p>The database contains a total of  ".$ntotal." puzzles!</p>\n";
  echo "<p></p>\n";
  if($lang==0)
  {
    echo "<p>Klik p tallet ud for den sudoku strrelse, du er interesseret i. Opgaverne\n";
    echo "er opdelt efter symmetrien i felterne. Se <a href=\"faq.html#3\">FAQ'en</a> for en beskrivelse af symmetriformerne.</p>\n";
    echo "<p>De store opgaver er mest lavet for sjov - jeg regner ikke med, at der er s mange, der kaster sig over disse for alvor.</p>\n";
    echo "<p>Er du nybegynder, s prv med 2x3 opgaver, 180 rotation, disse findes i alle svrhedsgrader.</p>\n";
    echo "<p>Klik <a href=\"pdf.php\">hr</a> for at hente mange opgaver med lsninger. Opgaverne hentes i en PDF fil - lige til at skrive ud.</p>\n";
    echo "<p><form method=post action=\"".$PHP_SELF."\">G direkte til opgave nr. <input name=serial size=7><input type=submit value=\"Vis\"></form></p>\n";
    echo "<p><b>Bemrk:</b> Databasen og webserveren krer p en gammel 450 MHz Pentium II maskine med 128M RAM, s opslagene tager nogle gange lidt tid...</p>\n";
  }
  else
  {
    echo "<p>Click on the number next to the size you're interested in. The puzzles\n";
    echo "are classified according to the symmetry. Please see the <a href=\"faq.html#3\">FAQ</a> for a description of the different symmetries.</p>\n";
    echo "<p>The large puzzles are made because they a fun to produce. I don't expect that many of these are actually solved by hand.</p>\n";
    echo "<p>If you are a beginner, I suggest that you start with the 2x3 puzzles, 180 rotation, as they exist in all levels of difficulty.</p>\n";
    echo "<p>Click <a href=\"pdf.php\">here</a> to fetch many puzzles. The puzzles are returned in a PDF file, ready for print.</p>\n";
    echo "<p><form method=post action=\"".$PHP_SELF."\">Go directly to puzzle no. <input name=serial size=7><input type=submit value=\"Show\"></form></p>\n";
    echo "<p><b>Note:</b> The database and webserver runs on an old 450 MHz Pentium II machine with 128M RAM. Sometimes, it runs a bit slowly...</p>\n";
  }
}

echo "</body>\n";
echo "</html>\n";
?>
