#!/bin/bash

mysql -usudoku -psudoku sudoku <<EOF

create table problems
(
  serial int not null,
  problem text not null,
  primary key(serial)
);

create table solutions
(
  serial int not null,
  solution text not null,
  primary key(serial)
);

create table explanations
(
  serial int not null,
  explanation text not null,
  primary key(serial)
);

insert into problems(serial,problem) select serial,problem from sudoku;
insert into solutions(serial,solution) select serial,solution from sudoku;
insert into explanations(serial,explanation) select serial,explanation from sudoku;

alter table sudoku drop column problem, drop column solution, drop column explanation;

optimize table sudoku;
optimize table problems;
optimize table solutions;
optimize table explanations;

EOF

