#!/bin/bash

mysql -usudoku -psudoku sudoku <<EOF

drop table if exists statistics;
drop table if exists stat;

create table statistics
(
  notused int not null auto_increment,
  nx int not null,
  ny int not null,
  ndigits int not null,
  level int not null,
  symmetrical int not null,
  counter int not null,
  primary key(notused),
  key(nx,ny),
  key(ndigits),
  key(level),
  key(symmetrical)
);

insert into statistics(nx,ny,ndigits,level,symmetrical,counter)
  select nx,ny,ndigits,level,symmetrical,count(serial) as counter from sudoku
  group by nx,ny,ndigits,level,symmetrical;
EOF

