#!/usr/bin/perl

use DBI;

$dbh = DBI->connect("DBI:mysql:database=sudoku;host=localhost", "sudoku", "sudoku");

$sth = $dbh->prepare("select sudoku.serial,problems.problem from sudoku,problems where sudoku.serial=problems.serial");
$sth->execute;

$serials = {};
@duplicates = ();
$nduplicates = 0;
$nrecords = 0;

while($row = $sth->fetchrow_hashref)
{
  $nrecords++;
  if(exists $serials->{$row->{"problem"}})
  {
    push @duplicates, $row->{"serial"};
    $nduplicates++;
  }
  else
  {
    $serials->{$row->{"problem"}} = $row->{"serial"};
  }
}

print "$nduplicates duplicates out of $nrecords sudokus.\n";

foreach $serial (@duplicates)
{
  $dbh->do("delete from sudoku where serial=$serial");
  $dbh->do("delete from problems where serial=$serial");
  $dbh->do("delete from solutions where serial=$serial");
  $dbh->do("delete from explanations where serial=$serial");
}

